"use strict";

var blacklist = ['covershut.com', 'searchednews.com', 'fansshare.com'];

var currentRequest = 0;
var currentResult = -1;
var cachedArtist;
var cachedAlbumArtist;
var cachedAlbum;
var cachedTitle;
var titleSearchUsed;
var lastResult;

var rGoogle;
var tryGoogle = true;
var useWhiteList = false;
var usingCustomPhrase = false;
var aR = new Array();
var aResult = new Array();
var reswlnum = 0;
var whitelist = new Array("grooveshark.com", "coveralia.com", "jazz.com", "bandzone.cz", "7digital.com", "7static.com", "ecover.to", "deejay.de", "deezer.com", "discogs.com", "djshop.de", "ebreggae.com", "eclassical.com", "textalk.se",
	"esenshop.com", "hitparade.ch", "hmv.ca", "chartstats.com", "itunes.apple.com", "juno.co.uk", "kalahari.com", "audioscrobbler.com", "maniadb.com", "mndigital.com", "mega-media.nl", "metal-archives.com",
	"metallibrary.ru", "nuclearblast.de", "psyshop.com", "qobuz.com", "revhq.com", "musique.sfr.fr", "soundstation.dk", "takealot.com", "theorchard.com", "vgmdb.net", "wantitall.co.za", "yesasia.com", "uulyrics.com");

function WebRequest() {
    this.host = '';
    this.name = '';
    this.className = '';
    this.onSuccess = null;
    this.onFailure = null;
}

function ImageResult() {
    this.imglink = '';
    this.height = '';
    this.width = '';
    this.thumblink = '';
}

var downloadPromise = null;

function NotifyWebReq(str) {

   // window.external.notify('1' + str);
    window.android.request(str);
}

function NotifyResult(res) {
//    window.external.notify('2' + res.imglink);
//    window.external.notify('3' + res.thumblink);
//    window.external.notify('4' + res.width + 'x' + res.height); 
    window.android.result(res.imglink, res.thumblink,  res.width,  res.height);
}

function NotifyDebug(str) {

   // window.external.notify('9' + 'JS: ' + str);
    window.android.debug("Debug: "+str);
}

function NotifyEnd() {
    //window.external.notify('8');
    window.android.onFinished(""+titleSearchUsed);
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
var rNextGoogle = function () {
    NotifyDebug('rNextGoogle');
    whatNext();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
var searchSend = function (r, a, t) {
//    NotifyDebug('SearchSend');
//    var site = r.className;
//    a = a.replace('&', '%26'); t = t.replace('&', '%26'); // Dirty Dirty hack.....
//    var host = r.host.replace('%artist%', a).replace('%album%', t);
//    host = encodeURI(host).replace('%2526', '%26');
//    try {
//        NotifyWebReq(host);
//    } catch (err) { }
 NotifyDebug('SearchSend');
    var site = r.className;
    var host;
    if (usingCustomPhrase)
        host = r.host.replace('%custom%', encodeURIComponent(a));
    else {
        var q = '';
        if (r.usingQuotation)
            q = '"';
        var artistList = a.split(';'); // can be more than one
        var astr = '';
        artistList.forEach(function (artist) {
            if (astr)
                astr += q + ' ' + q;
            astr +=  encodeURIComponent(artist);

        });

        host = r.host.replace('%artist%', astr).replace('%album%',  encodeURIComponent(t) );//encodeURIComponent(t)
    }
 //       host = encodeURI(host).replace('%2526', '%26');
    try {
        NotifyWebReq(host);
    } catch (err) {}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
var whatNext = function (init) {
	 var a;
        var t;
        a = cachedArtist;
        if (usingCustomPhrase) {
            t = '';
        } else {
            t = cachedAlbum;
        }
        if (init) {
            NotifyDebug('whatNext init');
        } else {
            NotifyDebug('whatNext continue');
            currentRequest++;
        }
        if (currentRequest < aR.length) {
            NotifyDebug('Calling search send');
            searchSend(aR[currentRequest], a, t);
        } else
            NotifyEnd();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function isAlphaNumeric(str) {
  var code, i, len;

  for (i = 0, len = str.length; i < len; i++) {
    code = str.charCodeAt(i);
    if (!(code > 47 && code < 58) && // numeric (0-9)
        !(code > 64 && code < 91) && // upper alpha (A-Z)
        !(code > 96 && code < 123)) { // lower alpha (a-z)
      return false;
    }
  }
  return true;
};

var AddResult = function (res) {
   NotifyDebug('AddResult ' + res.imglink);
    var iswl = false;

    if (useWhiteList) {
        for (var i = 0; whitelist[i]; i++) {
            if (res.imglink.search(whitelist[i]) != -1) {
                iswl = true;
                break;
            }
        }
    }

    if (iswl) {
        aResult.splice(reswlnum, 0, res);
        reswlnum++;
    } else {
        for (var i = 0; blacklist[i]; i++) {
             if (res.imglink.search(blacklist[i]) != -1) {
                  NotifyDebug('AddResult - blaclisted ' + blacklist[i]);
                    return;
             }
        }
            aResult.push(res);
    }
    NotifyDebug('AddResult END');


//
//                if (titleSearchUsed) {
//                    var wordsStr = cachedArtist + ' ' + cachedTitle;
//                } else {
//                    var wordsStr = cachedAlbumArtist + ' ' +cachedAlbum;
//                }
//
//                var words = wordsStr.split(" ");
//                var link = res.imglink.toLowerCase();
//                var notFoundCount = 0;
//                for (var i = 0; i < words.length; i++) {
//                    var word = words[i].toLowerCase();
//                    if (isAlphaNumeric(word) && link.indexOf(word) < 0) {
// //                       NotifyDebug('AddResult - refused: does not include word "' + word + '"'); // see mantis issue #13047 for details
// //                       add = false;
//                        ++notFoundCount;
//                        NotifyDebug('AddResult - refused: does not include word "' + word + '" notFoundCount: '+notFoundCount);
//                        break;
//                    }
//                }
//
//                var percent = calculatePercent(words.length-notFoundCount, words.length);
//                if (percent < 0.8){
//                    NotifyDebug('AddResult - refused: includes only ' + (percent*100) + '% of words'); // see mantis issue #13047 for details
//                    add = false;
//                }else{
//                    NotifyDebug('AddResult - accepted: includes ' + (percent*100) + '% of words'); // see mantis issue #13047 for details
//                }
//
//
//    if (add) {
//        aResult.push(res);
//        NotifyDebug('AddResult - accepted');
//    }
}
var rSuccessGoogle = function (html) {
    NotifyDebug('rSuccessGoogle');
       var googleRes = searchTools.parseGoogleImgSearchResponse(html);
       for (var i = 0; i < googleRes.length; i++) {
           AddResult(googleRes[i]);
       }
       if (aResult.length > 0) {
           for (var i = 0; i < aResult.length; i++) {
               NotifyResult(aResult[i]);
           }
           NotifyEnd();
           aResult.length = 0;
       } else
           whatNext();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
var init = function () {
	 NotifyDebug('init');
        aResult.length = 0;
        aR.length = 0;
        reswlnum = 0;
        currentRequest = 0;
        if (tryGoogle) {
            if (usingCustomPhrase) {
                rGoogle = new WebRequest();
                rGoogle.onSuccess = rSuccessGoogle;
                rGoogle.onFailure = rNextGoogle;
                rGoogle.host = 'https://www.google.com/search?safe=active&tbs=iar:s,ift:jpg&q=%custom%&tbm=isch';
                rGoogle.sendString = '';
                rGoogle.name = 'Google';
                rGoogle.className = 'Google';
                aR.push(rGoogle);
            } else {
                rGoogle = new WebRequest();
                rGoogle.onSuccess = rSuccessGoogle;
                rGoogle.onFailure = rNextGoogle;
                rGoogle.host = 'https://www.google.com/search?safe=active&tbs=iar:s,ift:jpg&q="%artist%"+"%album%"&tbm=isch';
                rGoogle.sendString = '';
                rGoogle.name = 'Google';
                rGoogle.className = 'Google';
                rGoogle.usingQuotation = true;
                aR.push(rGoogle);

                // second request - try without quotation marks
                rGoogle = new WebRequest();
                rGoogle.onSuccess = rSuccessGoogle;
                rGoogle.onFailure = rNextGoogle;
                rGoogle.host = 'https://www.google.com/search?safe=active&tbs=iar:s,ift:jpg&q=%artist%+%album%&tbm=isch';
                rGoogle.sendString = '';
                rGoogle.name = 'Google';
                rGoogle.className = 'Google';
                rGoogle.usingQuotation = false;
                aR.push(rGoogle);
            }
        }
        whatNext(true);
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function noParenthesis(str) {
    // LS: eliminate parenthesis, it mostly includes featuring artists etc. , see mantis #13047 for details
    var res = str;
    if (str.indexOf('(') >= 0)
        res = str.substring(0, str.indexOf('('));
    if (str.indexOf('{') >= 0)
        res = str.substring(0, str.indexOf('{'));
    if (str.indexOf('[') >= 0)
        res = str.substring(0, str.indexOf('['));
    return res;
};

var SearchAA = function (albumArtist, artist, album, title) {
    NotifyDebug('SearchAA: Album Artist: '+albumArtist+' ,Artist: '+artist+' ,Album: '+album+' ,Title: '+title+' ,currentResult = '+currentResult);

    cachedAlbumArtist = noParenthesis( albumArtist);
    cachedArtist = noParenthesis( artist);
    cachedAlbum = noParenthesis( album);
    cachedTitle = noParenthesis( title);
    usingCustomPhrase = false;
    init();
    currentResult++; // so that next time another image is used
    return lastResult;
}



var LoadedWebPage = function (webcontent) {
    NotifyDebug('LoadedWebPage');
    if ((currentRequest < aR.length) && (aR[currentRequest].onSuccess != null)) {
        aR[currentRequest].onSuccess(webcontent);
    }
}
var LoadWebPageFailed = function () {
    NotifyDebug('LoadWebPageFailed');
    if ((currentRequest < aR.length) && (aR[currentRequest].onFailure != null)) {
        aR[currentRequest].onFailure();
    }
}


var calculatePercent = function(part, total){
    NotifyDebug('calculatePercent: ' + part + ' total '+total);
    if (part <= 0){
        return 0;
    }
    return part/total
}

//searchTools.interfaces.aaSearch.startSearch = function (artist, title) {
//    NotifyDebug('SearchAA: Artist: ' + artist + ' ,Album: ' + title);
//    cachedArtist = artist || ''; // to avoid undefined value
//    cachedAlbum = title || '';
//    usingCustomPhrase = false;
//    init();
//}
//searchTools.interfaces.aaSearch.startCustomSearch = function (searchPhrase) {
//    NotifyDebug('SearchAA: ' + searchPhrase);
//    cachedArtist = searchPhrase;
//    usingCustomPhrase = true;
//    init();
//}
//searchTools.interfaces.aaSearch.defaultSearchPhrase = function (artist, title) {
//    var retval = ''
//    if (artist)
//        retval = '"' + artist + '"';
//    if (title) {
//        if (retval)
//            retval += '+';
//        retval += '"' + title + '"';
//    }
//    return retval;
//}

